function R = matching(x1,x2,x3,wx,gtabx,y1,y2,y3,wy,gtaby,sigmaI2,sqnormy);

% matching norm for measure matching
% computes |mu_x - mu_y|^2 with kernel size sigmaI
%
% author : Joan Glaunès - joan.glaunes@free.fr

ng = length(gtabx)-1;

R = 0;
for g = 1:ng
    for k = gtabx(g):gtabx(g+1)-1
        % squared norm of x
        for l = gtabx(g):gtabx(g+1)-1
            arg = -( ...
                (x1(l)-x1(k))^2 + ...
                (x2(l)-x2(k))^2 + ...
                (x3(l)-x3(k))^2)/sigmaI2;
            arg = 1/(1-arg);  %% BUILT IN KERNEL kerI, do not remove this comment              
            R = R + wx(k)*wx(l)*arg;
        end
        % cross term
        for l = gtaby(g):gtaby(g+1)-1
            arg = -( ...
                (y1(l)-x1(k))^2 + ...
                (y2(l)-x2(k))^2 + ...
                (y3(l)-x3(k))^2)/sigmaI2;
            arg = 1/(1-arg);  %% BUILT IN KERNEL kerI, do not remove this comment                             
            R = R - 2*wx(k)*wy(l)*arg;
        end
    end
end

% squared norm of y
if exist('sqnormy') == 1
    R = R + sqnormy;
else
    for g = 1:ng
        for k = gtaby(g):gtaby(g+1)-1
            % squared norm of template measure
            for l = gtaby(g):gtaby(g+1)-1
                arg = -( ...
                    (y1(l)-y1(k))^2 + ...
                    (y2(l)-y2(k))^2 + ...
                    (y3(l)-y3(k))^2)/sigmaI2;
                arg = 1/(1-arg);  %% BUILT IN KERNEL kerI, do not remove this comment              
                R = R + wy(k)*wy(l)*arg;
            end
        end
    end
end


    
